
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Game_guestsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_guests = await db.game_guests.create(
            {
                id: data.id || undefined,
        
        nickname: data.nickname
        ||
        null
            ,
            
        rsvp_status: data.rsvp_status
        ||
        null
            ,
            
        attendance_status: data.attendance_status
        ||
        null
            ,
            
        payment_status: data.payment_status
        ||
        null
            ,
            
        seed_tier_for_balance: data.seed_tier_for_balance
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await game_guests.setGame( data.game || null, {
            transaction,
        });
        
        await game_guests.setAdded_by_user( data.added_by_user || null, {
            transaction,
        });
        
        await game_guests.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return game_guests;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const game_guestsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                nickname: item.nickname
            ||
            null
            ,
            
                rsvp_status: item.rsvp_status
            ||
            null
            ,
            
                attendance_status: item.attendance_status
            ||
            null
            ,
            
                payment_status: item.payment_status
            ||
            null
            ,
            
                seed_tier_for_balance: item.seed_tier_for_balance
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const game_guests = await db.game_guests.bulkCreate(game_guestsData, { transaction });

        // For each item created, replace relation files
        

        return game_guests;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const game_guests = await db.game_guests.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.nickname !== undefined) updatePayload.nickname = data.nickname;
        
        
        if (data.rsvp_status !== undefined) updatePayload.rsvp_status = data.rsvp_status;
        
        
        if (data.attendance_status !== undefined) updatePayload.attendance_status = data.attendance_status;
        
        
        if (data.payment_status !== undefined) updatePayload.payment_status = data.payment_status;
        
        
        if (data.seed_tier_for_balance !== undefined) updatePayload.seed_tier_for_balance = data.seed_tier_for_balance;
        
        
        updatePayload.updatedById = currentUser.id;

        await game_guests.update(updatePayload, {transaction});

        
        
        if (data.game !== undefined) {
            await game_guests.setGame(
              
              data.game,
              
              { transaction }
            );
        }
        
        if (data.added_by_user !== undefined) {
            await game_guests.setAdded_by_user(
              
              data.added_by_user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await game_guests.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return game_guests;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_guests = await db.game_guests.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of game_guests) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of game_guests) {
                await record.destroy({transaction});
            }
        });


        return game_guests;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const game_guests = await db.game_guests.findByPk(id, options);

        await game_guests.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await game_guests.destroy({
            transaction
        });

        return game_guests;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const game_guests = await db.game_guests.findOne(
            { where },
            { transaction },
        );

        if (!game_guests) {
            return game_guests;
        }

        const output = game_guests.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.game_team_assignments_guest = await game_guests.getGame_team_assignments_guest({
            transaction
        });
        
        
        output.game_attendances_guest = await game_guests.getGame_attendances_guest({
            transaction
        });
        
        
        
        output.game_payments_guest = await game_guests.getGame_payments_guest({
            transaction
        });
        
        
        
        
        
        
        
        
        output.game = await game_guests.getGame({
            transaction
        });
        
        
        output.added_by_user = await game_guests.getAdded_by_user({
            transaction
        });
        
        
        output.organizations = await game_guests.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.games,
        as: 'game',
        
        where: filter.game ? {
          [Op.or]: [
            { id: { [Op.in]: filter.game.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.game.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'added_by_user',
        
        where: filter.added_by_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.added_by_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.added_by_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.nickname) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'game_guests',
                        'nickname',
                        filter.nickname,
                    ),
                };
            }
            

            
            

            
            if (filter.seed_tier_for_balanceRange) {
                const [start, end] = filter.seed_tier_for_balanceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    seed_tier_for_balance: {
                    ...where.seed_tier_for_balance,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    seed_tier_for_balance: {
                    ...where.seed_tier_for_balance,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.rsvp_status) {
                where = {
                    ...where,
                rsvp_status: filter.rsvp_status,
            };
            }
            
            if (filter.attendance_status) {
                where = {
                    ...where,
                attendance_status: filter.attendance_status,
            };
            }
            
            if (filter.payment_status) {
                where = {
                    ...where,
                payment_status: filter.payment_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.game_guests.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'game_guests',
                        'nickname',
                        query,
                    ),
                ],
            };
        }

        const records = await db.game_guests.findAll({
            attributes: [ 'id', 'nickname' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['nickname', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.nickname,
        }));
    }

    
};

